<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../../">
  <title data-ice="title">public/js/catalouge/Filter/Filter.js | archive-system-front-end</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
</head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/ArchiveSys/Web-Catalogue/archive-system-front-end.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js">js</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/moodral.js~moodral.html">moodral</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CONFIG">CONFIG</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge">js/catalouge</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System.js~Catalog_System.html">Catalog_System</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System_Base.js~Catalog_System_Base.html">Catalog_System_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-archive-connection">js/catalouge/Archive_Connection</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Archive_Connection/Archive_Connection.js~Archive_Connection.html">Archive_Connection</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry">js/catalouge/Catalog_Entry</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry.js~Catalog_Entry.html">Catalog_Entry</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js~Catalog_Entry_Base.html">Catalog_Entry_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry-moodral">js/catalouge/Catalog_Entry_Moodral</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry_Moodral/Catalog_Entry_Moodral.js~Catalog_Entry_Moodral.html">Catalog_Entry_Moodral</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-filter">js/catalouge/Filter</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter.js~Filter.html">Filter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter_Base.js~Filter_Base.html">Filter_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-page-headers">js/catalouge/Page_Headers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Page_Headers/Page_Headers.js~Page_Headers.html">Page_Headers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-toolkit">js/toolkit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/baseToolkit.js~toolkit.html">toolkit</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~baseStorageToolkitExtention.html">baseStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~permanentStorageToolkitExtention.html">permanentStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~sessionStorageToolkitExtention.html">sessionStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/contentToolkitExtention.js~contentToolkitExtention.html">contentToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/endlessScrollToolkitExtention.js~endlessScrollToolkitExtention.html">endlessScrollToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/eventToolkitExtention.js~eventToolkitExtention.html">eventToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/formToolkitExtention.js~formToolkitExtention.html">formToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/httpConnectionsToolkitExtention.js~httpConnectionsToolkitExtention.html">httpConnectionsToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/styleToolkitExtention.js~styleToolkitExtention.html">styleToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/urlToolkitExtention.js~urlToolkitExtention.html">urlToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-aggregator">aggregator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-NOTHING">NOTHING</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">public/js/catalouge/Filter/Filter.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import { Filter_Base } from &apos;./Filter_Base.js&apos;;
import moodral from &apos;./../../moodral.js&apos;;

import { aggregator, toolkit } from &apos;./../../toolkit/baseToolkit.js&apos;;
import {contentToolkitExtention} from &apos;./../../toolkit/contentToolkitExtention.js&apos;;
import {eventToolkitExtention} from &apos;./../../toolkit/eventToolkitExtention.js&apos;;
import {styleToolkitExtention} from &apos;./../../toolkit/styleToolkitExtention.js&apos;;

class tk extends aggregator(toolkit, contentToolkitExtention, eventToolkitExtention, styleToolkitExtention) {};

/**
 * The Filter object that handles changing the filters
 * @extends {Filter_Base}
 */
export class Filter extends Filter_Base {

  /**
   * The constructor.
   * @public
   * @param {Catalog_System} catalog - the parrent catalog object.
   */
  constructor(catalog) {
    super(catalog);
    let self = this;

    /**
     * The options moodral toolkit.
     * @public
     * @type {toolkit}
     */
    this.moodral = new moodral(&quot;SearchBoxMoodral&quot;);
    this.moodral.addCloseButton(&quot;.moodralClose&quot;);
    // I don&apos;t trust `this`.
    let filterMoodral = this.moodral;
    document.getElementById(&apos;openSearchBoxMoodral&apos;).addEventListener(&quot;click&quot;, (e) =&gt; filterMoodral.show(), false);

    /**
     * The page &amp; results displayer CSS Selector.
     * @private
     * @type {String}
     */
    this.pnr = &quot;#pagesNresults&quot;;

    // set the triggers
    this.setTriggers();
  }

  /**
   * Set&apos;s the filter menu triggers.
   * While technically public, in reality nothing should need to access this.
   * @private
   */
  setTriggers() {
    let self = this;
    let filterForum = new tk(&apos;.searchbox&apos;);
    filterForum.addListener(&quot;submit&quot;, function(evt) {
      evt.preventDefault();
      self.onFilterSubmit(true);
    });
    filterForum.searchChildren(&apos;select&apos;);
    filterForum.addListener(&quot;change&quot;, function() {
      self.onFilterSubmit(false);
    });
  }

  /**
   * Ran whenever a filter update is triggered.
   * Trigger this if your userscript has made changes to any options.
   * @public
   * @param {boolean} close - If it should auto-close the search box.
   */
  onFilterSubmit(close=false) {
    this.setPage(1);
    this.__generatePayload();
    this.catalog.reloadFilter();
    if(close){
      this.moodral.closeMoodral();
    }
  }

  /**
   * Set&apos;s the author ID
   * @public
   * @param {number} authorID - the author ID to set.
   */
   setAuthorID(authorID){
     let elm = document.getElementById(&quot;st-author&quot;);
     elm.value = authorID;
   }

  /**
   * Generate Payload for HTTP requests.
   * @private
   */
  __generatePayload(){
    // New PayLoad;
    let sets = [[&quot;STall&quot;, &quot;st-main&quot;], [&quot;STauthor&quot;,&quot;st-author&quot;], [&quot;STgenre&quot;,&quot;st-genre&quot;], [&quot;STkeyword&quot;,&quot;st-key&quot;],
    [&quot;NMpublisher&quot;,&quot;publisher&quot;], [&quot;NMcatagory&quot;,&quot;category&quot;], [&quot;NMrating&quot;,&quot;rating&quot;], [&quot;NMstatus&quot;,&quot;status&quot;],
    [&quot;NMchapMin&quot;,&quot;min-chap&quot;], [&quot;NMchapMax&quot;,&quot;max-chap&quot;], [&quot;NMwordMin&quot;,&quot;min-words&quot;], [&quot;NMwordMax&quot;,&quot;max-words&quot;]];
    let selectors = []
    for(let id in sets){
      let set = sets[id];
      let v = this.__getValue(set[1]);
      if(v){
        selectors.push({&quot;type&quot;:set[0], &quot;value&quot;:v});
      }
    }
    if (this.x){
      selectors.push({&quot;type&quot;:&quot;reveal&quot;});
    }
    let npl = {selectors};
    npl.sort = this.__getValue(&quot;sort&quot;);
    npl.offset = this.page;
    this.__payload = npl;
  }

  /**
   * Removes all filter options and re-adds the dummy option.
   * @private
   * @param {String} selectID - The ID of the element.
   * @param {String} dummyString - The string for the dummy item.
   */
  __resetOptions(selectID, dummyString){
    let dummyOption = &apos;&lt;option value=&quot;dummy&quot;&gt;&apos; + dummyString + &apos;:&lt;/option&gt;&apos;;
    let v = this.__getValue(selectID);
    let selectElement = new tk(&quot;#&quot;+selectID);
    selectElement.replaceHTML(dummyOption);
    return v;
  }

  /**
   * Makes a option node that can be added to a select element.
   * @private
   * @param {Object} optionData - the actual option data.
   * @return {Node}
   */
  __makeOption(optionData){
    let newOption = document.createElement(&apos;option&apos;);
    // boolean ? true condition : false condition
    let optionName = optionData.OptionAlt ? optionData.OptionAlt : optionData.OptionName;
    let optionText = optionName + &quot; (&quot; + optionData.OptionCount + &quot;)&quot;;
    if (optionData.OptionText) {
      optionText = optionData.OptionText;
    }
    newOption.title = optionText;
    newOption.value = optionData.OptionID;
    newOption.innerHTML = optionText;
    return newOption;
  }

  /**
   * Adds all the new options.
   * @private
   * @param {String} selectID - The ID of the element.
   * @param {Array&lt;Object&gt;} newOptions - The ID of the element.
   * @param {String} payloadItem - The payloadValue containing the last selected item.
   */
  __addOptions(selectID, newOptions, payloadItem){
    let selectElement = new tk(&quot;#&quot;+selectID);
    let added = 0
    for (let k in newOptions){
      // Some guy on stack exchange said to do this.
      if (newOptions.hasOwnProperty(k)) {
        selectElement.appendHTML(this.__makeOption(newOptions[k]));
        added++;
      }
    }
    payloadItem = payloadItem || &quot;dummy&quot;;
    if(added == 0){
      selectElement.appendHTML(this.__makeOption({&apos;OptionText&apos;:&quot;No valid options were found.&quot;, &apos;OptionID&apos;:&quot;dummy2&quot;}));
      payloadItem = &quot;dummy2&quot;;
    }
    selectElement.doEach(function(element, index) {
      element.value = payloadItem;
    })
  }

  /**
   * Should update the filter object with the new objects and re-display them.
   * If the options don&apos;t change, it should not update the options.
   * @todo actually implement this.
   */
  updateOptions(newOptions) {
    super.updateOptions(newOptions);
    let results = new tk(this.pnr + &quot; #ResCount&quot;).replaceText(this.total_results);
    let pages = new tk(this.pnr + &quot; #PgsCount&quot;).replaceText(this.max_page);
    // reset the options again. Just in-case.
    let publisher = this.__resetOptions(&quot;publisher&quot;,&quot;Publisher&quot;);
    let category = this.__resetOptions(&quot;category&quot;,&quot;Category&quot;);
    let rating = this.__resetOptions(&quot;rating&quot;,&quot;Rating&quot;);
    let status = this.__resetOptions(&quot;status&quot;,&quot;Status&quot;);
    // add the new options.
    this.__addOptions(&quot;publisher&quot;, this.publishers, publisher);
    this.__addOptions(&quot;category&quot;, this.catagorys, category);
    this.__addOptions(&quot;rating&quot;, this.ratings, rating);
    this.__addOptions(&quot;status&quot;, this.status, status);
  }
}
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
